#include <spdlog/spdlog.h>

#include "include/reset.hpp"
#include "include/Encoders.hpp"
#include "include/OdometryController.hpp"
#include "include/ClosedLoopMotorController.hpp"

using namespace std;

int main() {
  Reset::reset_robot();
  spdlog::set_pattern("%H:%M:%S.%e %^%-8l%$: %v");

  ClosedLoopMotorController::getInstance().set_speed(0, -125);
  ClosedLoopMotorController::getInstance().set_speed(3, 125);
  OdometryController::getInstance().enable();

  for (int i = 0; i < 10000; ++i) {
    auto odom = OdometryController::getInstance().get();
    spdlog::info("X {} Y {} W {}", odom.get_x_position(), odom.get_y_position(), odom.get_angular_orientation());
    usleep(1000);
  }
  return 0;
}
